
#include "stdafx.h"


#include "etc.h"

#include "wos.h"
#include "deb.h"


#include "prompts.h"




int main(int argc,char * argv[])
{ 
 os_error * err;
 char       path[MAX_PATH];
 char       group[MAX_PATH];
 int        groupdata=0;


 installinitlog("David Pilling's Trace");

prompt1:
 err=prompt1stage(
                  "This program will install David Pilling's Trace on your computer",
                  "It is a good idea to ensure that no other programs are running whilst installation is taking place",
                  "Trace is a copyright piece of software so you must comply with the restrictions in the Trace licence when making copies."
                  );


licence:
 err=licencestage("Please read the licence agreement below. Scroll through all of it.","If you have read the agreement and accept it, click on Agree to continue.",NULL,"licence.txt");
 if(err==errback) goto prompt1;


directory:
 err=programfilesdirectory(path,sizeof(path),"\\DavidPilling\\Trace");

 err=installerror(err);
 if(err==errback) goto directory;



 err=directorystage(
                    "Trace will be installed in the directory below. You can click on the browse button to pick a different directory.",
                    path,
                    sizeof(path)
                   );
 if(err==errback) goto licence;


programgroup:
 err=programgroupstage(
                       "Install will add Trace to the start menu program folder below. You can select a folder from the list shown or enter a new name.",
                       "DavidPilling",
                       group,sizeof(group),&groupdata
                      );
 if(err==errback) goto directory;




prompt2:
 err=prompt2stage(
                  "You are now ready to install Trace.",
                  "Click on Continue to commence installation.",
                  ""
                  );
 if(err==errback) goto programgroup;


startinstall:

          err=installdirectory(path);
 if(!err) err=installfile("DPTrace.exe",path);
 if(!err) err=installfile("trace.chm",path);
 if(!err) err=installfile("Uninstall.exe",path);
 if(!err) err=installgroup(group,groupdata,path,"DPTrace.exe","Trace.lnk","Trace",0);
 if(!err) err=installentry("HKLM\\Software\\Microsoft\\Windows\\CurrentVersion\\App Paths\\DPTrace.exe\\","%s\\DPTrace.exe",path);
 if(!err) err=installentry("HKLM\\Software\\Microsoft\\Windows\\CurrentVersion\\App Paths\\DPTrace.exe\\Path",path);
 if(!err) err=installentry("HKLM\\Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\DPTrace\\",NULL);
 if(!err) err=installentry("HKLM\\Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\DPTrace\\DisplayName","David Pilling's Trace");
 if(!err) err=installentry("HKLM\\Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\DPTrace\\UninstallString","\"%s\\Uninstall.exe\" \"%s\\install.log\"",path,path);
 if(!err) err=installentry("HKLM\\Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\DPTrace\\Contact","David Pilling");
 if(!err) err=installentry("HKLM\\Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\DPTrace\\Publisher","David Pilling");
 if(!err) err=installentry("HKLM\\Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\DPTrace\\HelpLink","david@davidpilling.net");
 if(!err) err=installentry("HKLM\\Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\DPTrace\\URLInfoAbout","http://www.davidpilling.net/trace.html");
 if(!err) err=installentry("HKLM\\Software\\DavidPilling\\Trace\\",NULL);
 if(!err) err=installtimestamp("HKLM\\Software\\DavidPilling\\Trace\\RegData");

 err=installerror(err);
 if(err==errback) goto prompt2;
 if(err==errback1) goto startinstall;

 installfinitlog(path,"install.log");

 err=prompt3stage(
                  "",
                  "The installation of Trace is now complete, you can run the program by using the start menu icons that have been created",
                  "Click on OK to finish this program"
                 );


 return(0);
 USE(argc);
 USE(argv);
}